> ## Documentation Index
> Fetch the complete documentation index at: https://www.latitude.sh/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Create VPN session

> Creates a new VPN Session.
`NOTE:` The VPN credentials are only listed ONCE upon creation. They can however be refreshed or deleted.




## OpenAPI

````yaml https://spec.speakeasy.com/latitude/latitude/latitude-sh-api-with-code-samples post /vpn_sessions
openapi: 3.0.1
info:
  title: Latitude.sh API
  version: '2023-06-01'
  description: >-
    The Latitude.sh API is a RESTful API to manage your Latitude.sh account. It
    allows you to perform the same actions as the Latitude.sh dashboard.
servers:
  - url: https://api.latitude.sh
    variables:
      latitude_api_key:
        default: <insert your api key here>
  - url: http://api.latitude.sh
    variables:
      latitude_api_key:
        default: <insert your api key here>
security: []
tags:
  - name: API keys
  - name: Billing
  - name: Elastic Ips
  - name: Events
  - name: Firewalls
  - name: IP Addresses
  - name: Kubernetes Clusters
  - name: Operating Systems
  - name: Plans
  - name: Private Networks
  - name: Projects
  - name: Regions
  - name: Roles
  - name: SSH Keys
  - name: Servers
  - name: Storage
  - name: Tags
  - name: Teams
  - name: Team members
  - name: Traffic
  - name: User data
  - name: User profile
  - name: VPN Sessions
  - name: Virtual machines
paths:
  /vpn_sessions:
    post:
      tags:
        - VPN Sessions
      summary: Create VPN session
      description: >
        Creates a new VPN Session.

        `NOTE:` The VPN credentials are only listed ONCE upon creation. They can
        however be refreshed or deleted.
      operationId: post-vpn-session
      parameters: []
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                data:
                  properties:
                    type:
                      type: string
                      enum:
                        - vpn_sessions
                    attributes:
                      type: object
                      properties:
                        site:
                          type: string
                          enum:
                            - ASH
                            - BUE
                            - CHI
                            - DAL
                            - FRA
                            - LAX
                            - LON
                            - MEX
                            - MEX2
                            - MIA
                            - MIA2
                            - NYC
                            - SAO
                            - SAO2
                            - SGP
                            - SYD
                            - TYO
                            - TYO2
                        server_id:
                          type: string
            examples:
              Created:
                summary: Created
                value:
                  data:
                    attributes:
                      site: SAO
                      server_id: sv_LMmAD8wyqwop2
          application/vnd.api+json:
            schema:
              type: object
              properties:
                data:
                  properties:
                    type:
                      type: string
                      enum:
                        - vpn_sessions
                    attributes:
                      type: object
                      properties:
                        site:
                          type: string
                          enum:
                            - ASH
                            - BUE
                            - CHI
                            - DAL
                            - FRA
                            - LAX
                            - LON
                            - MEX
                            - MEX2
                            - MIA
                            - MIA2
                            - NYC
                            - SAO
                            - SAO2
                            - SGP
                            - SYD
                            - TYO
                            - TYO2
                        server_id:
                          type: string
            examples:
              Created:
                summary: Created
                value:
                  data:
                    attributes:
                      site: SAO
                      server_id: sv_LMmAD8wyqwop2
        required: true
      responses:
        '201':
          description: Created
          content:
            application/vnd.api+json:
              examples:
                Created:
                  value:
                    data:
                      id: vpn_VLMmAD8EOwop2
                      type: vpn_sessions
                      attributes:
                        user_name: Cameron
                        password: 8EqcGL2tsQngWe
                        port: '8443'
                        host: fw04-mh1.maxi.host
                        region:
                          city: São Paulo 277
                          country: Brazil 290
                          site:
                            id: loc_VE1Wd3wQdXnZJ
                            name: São Paulo 277
                            slug: SAO
                            facility: São Paulo 277
                        expires_at: '2026-01-14T15:58:20+00:00'
                        created_at: '2026-01-14T15:57:20+00:00'
                        updated_at: '2026-01-14T15:57:20+00:00'
                    meta: {}
              schema:
                $ref: '#/components/schemas/vpn_session_with_password'
      security:
        - Bearer: []
      x-codeSamples:
        - lang: python
          label: Python (SDK)
          source: |-
            import latitudesh_python_sdk
            from latitudesh_python_sdk import Latitudesh
            import os


            with Latitudesh(
                bearer=os.getenv("LATITUDESH_BEARER", ""),
            ) as latitudesh:

                res = latitudesh.vpn_sessions.create(data={
                    "attributes": {
                        "site": latitudesh_python_sdk.PostVpnSessionVpnSessionsSite.SAO,
                        "server_id": "sv_LMmAD8wyqwop2",
                    },
                })

                # Handle response
                print(res)
        - lang: go
          label: Go (SDK)
          source: "package main\n\nimport(\n\t\"context\"\n\t\"os\"\n\tlatitudeshgosdk \"github.com/latitudesh/latitudesh-go-sdk\"\n\t\"github.com/latitudesh/latitudesh-go-sdk/models/operations\"\n\t\"log\"\n)\n\nfunc main() {\n    ctx := context.Background()\n\n    s := latitudeshgosdk.New(\n        latitudeshgosdk.WithSecurity(os.Getenv(\"LATITUDESH_BEARER\")),\n    )\n\n    res, err := s.VpnSessions.Create(ctx, operations.PostVpnSessionVpnSessionsRequestBody{\n        Data: &operations.PostVpnSessionVpnSessionsData{\n            Attributes: &operations.PostVpnSessionVpnSessionsAttributes{\n                Site: operations.PostVpnSessionVpnSessionsSiteSao.ToPointer(),\n                ServerID: latitudeshgosdk.Pointer(\"sv_LMmAD8wyqwop2\"),\n            },\n        },\n    })\n    if err != nil {\n        log.Fatal(err)\n    }\n    if res.VpnSessionWithPassword != nil {\n        // handle response\n    }\n}"
        - lang: typescript
          label: Typescript (SDK)
          source: |-
            import { Latitudesh } from "latitudesh-typescript-sdk";

            const latitudesh = new Latitudesh({
              bearer: process.env["LATITUDESH_BEARER"] ?? "",
            });

            async function run() {
              const result = await latitudesh.vpnSessions.create({
                data: {
                  attributes: {
                    site: "SAO",
                    serverId: "sv_LMmAD8wyqwop2",
                  },
                },
              });

              console.log(result);
            }

            run();
components:
  schemas:
    vpn_session_with_password:
      type: object
      properties:
        data:
          $ref: '#/components/schemas/vpn_session_data_with_password'
    vpn_session_data_with_password:
      type: object
      properties:
        id:
          type: string
        type:
          type: string
          enum:
            - vpn_sessions
        attributes:
          type: object
          properties:
            user_name:
              type: string
              description: VPN username
            password:
              type: string
              description: VPN password
            port:
              type: string
              description: VPN port
            host:
              type: string
              description: VPN host
            region:
              $ref: '#/components/schemas/region_resource_data'
            status:
              type: string
              enum:
                - enable
                - disable
              description: from Firewall Response
            expires_at:
              type: string
              description: Time to expiry
            created_at:
              type: string
            updated_at:
              type: string
    region_resource_data:
      type: object
      properties:
        city:
          type: string
        country:
          type: string
        site:
          type: object
          properties:
            id:
              type: string
            facility:
              type: string
            name:
              type: string
            slug:
              type: string
  securitySchemes:
    Bearer:
      type: apiKey
      name: Authorization
      in: header

````